var moduleData = new ActiveXObject("Microsoft.XMLDOM");
moduleData.load("data/beweegtugenoeg.xml");
var moduleRoot = moduleData.documentElement;

var styleData = new ActiveXObject("Microsoft.XMLDOM");

var chosenDag = '';
var chosenDagNum = -1;
var weekNum = 1;
var minMax = new Array(1,52,0,1440,0,1440,0,1440);
var chosenTab = -1;
var stepDotStep = 0;
var stepTexts = new Array('Blader naar de gewenste week. Kies vervolgens een dag.',
'Kies een bewegingsvorm door n van tabbladen aan te klikken. Wilt u de gegevens overnemen van een reeds ingevulde dag, gebruik dan de knoppen <img src="images/btn_copy_0.bmp" width="29" height="10" alt="" border="0" style="position:relative; top:2px"/> en <img src="images/btn_paste_0.bmp" width="29" height="10" alt="" border="0" style="position:relative; top:2px"/> .',
'Vul het aantal minuten in dat u met een bepaalde intensiteit bewogen heeft. Voor voorbeelden kiest u <img src="images/help_help.gif" width="14" height="14" alt="" border="0" style="position:relative; top:3px"/>. Bent u klaar, kies dan de volgende dag.',
'U heeft alle dagen van de week ingevuld, kies rechts voor <img src="images/help_ok.gif" width="16" height="16" alt="" border="0" style="position:relative; top:3px"/> om uw weekresultaat te berekenen.');
var stepDotTimer;
var gewicht = parseFloat(parent.userRoot.selectSingleNode("gewicht").text);
var factor1 = 3;
var factor2 = 5.25;
var factor3 = 8;
var cpweek = -1;
var cpdag = '';
var weekResult = false;
var groeneWeken = false; // blijft altijd false

function showPage() {
  buildPage();
  parent.goPage = 'beweegtugenoeg.html';
  AppScreen.style.visibility = "visible";
  for (var i=0; i<CountBox.length; i++) {
    CountBox[i].style.visibility = "inherit";
    }
  }

function buildPage() {
  stepIt();
  getWeek();
  }
  
function stepIt() {
  for (var i=0; i<StepDot.length; i++) {
    StepDot[i].src = "images/dot_0.gif";
    }
  StepDot[stepDotStep].src = "images/dot_1.gif";
  StepArea.innerHTML = stepTexts[stepDotStep];
  stepDotTimer = window.setTimeout("stopStep()",10000);
  }

function stopStep() {
  clearTimeout(stepDotTimer)
  for (var i=0; i<StepDot.length; i++) {
    StepDot[i].src = "images/dot_0.gif";
    }
  }
  
function CountAction(c) {
  theNum = c;
  theValue = parseInt(CountBox[c].value);
  if ((theValue >= minMax[theNum*2]) && (theValue <= minMax[(theNum*2)+1])) {
    CountBox[c].value = parseInt(CountBox[c].value);
    }
  else CountBox[c].value = minMax[theNum*2];
  
  if (theNum == 0) { // week
    weekNum = parseInt(CountBox[0].value);
    
    chosenDag = '';
    chosenDagNum = -1;
    for (var i=0; i<DagBtn.length; i++) {
      DagBtn[i].style.backgroundImage = "url('images/bt_dag_"+DagBtn[i].dag+((DagBtn[i].dag == chosenDag)?"_2":"_0")+".gif')";
      }
    TabArea.style.backgroundImage = "url('images/tab_default.bmp')";
    TabImg.filters.blendTrans.Apply();
    TabImg.src = "images/bck_meettab_default.bmp";
    TabImg.filters.blendTrans.Play();
    chosenTab = -1;
    
    CopyPaste.style.visibility = 'hidden';
    
    getWeek();
    
    stepDotStep = 0;
    stepIt();
    }
  else calculateDag();
  }

function calculateDag() {
  if (chosenTab == -1) {
    CountBox[1].value = 0;
    CountBox[2].value = 0;
    CountBox[3].value = 0;  
    return;
    }

  gewicht = parseInt(parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']").getAttribute("gewicht"));
    
  r1 = Math.round(parseInt(CountBox[1].value)/60*factor1*gewicht); // laag
  r2 = Math.round(parseInt(CountBox[2].value)/60*factor2*gewicht); // matig
  r3 = Math.round(parseInt(CountBox[3].value)/60*factor3*gewicht); // zwaar
  subtot = r1 + r2 + r3; // totaal van activiteit
  norm = Math.round(30/60*factor2*gewicht);

  ResultBox[chosenTab].innerText = subtot;
  ResultBox[chosenTab].subtot = subtot;
  ResultBox[chosenTab].teltot = r2 + r3;

  t = parseInt(ResultBox[0].subtot)+parseInt(ResultBox[1].subtot)+parseInt(ResultBox[2].subtot)+parseInt(ResultBox[3].subtot)+parseInt(ResultBox[4].subtot);
  teltot = parseInt(ResultBox[0].teltot)+parseInt(ResultBox[1].teltot)+parseInt(ResultBox[2].teltot)+parseInt(ResultBox[3].teltot)+parseInt(ResultBox[4].teltot);  
 
  DagBox[chosenDagNum].innerText = t;
  if (teltot<norm) {
    DagBox[chosenDagNum].className = 'dagBoxRed';
    result = 'r';
    }
  else if (teltot>=norm) {
    DagBox[chosenDagNum].className = 'dagBoxGreen';
    result = 'g';
    }

  if (DagBox[chosenDagNum].innerText != '0') {
    CopyPasteBtn[0].style.visibility = 'inherit';
    CopyPaste.style.visibility = 'inherit';
    }
  else CopyPaste.style.visibility = 'hidden';
  
  if (cpweek != -1) {
    CopyPasteBtn[1].style.visibility = 'inherit';
    CopyPaste.style.visibility = 'inherit';  
    }    
    
  checkWeekComplete();

  putResultInDag(CountBox[1].value,CountBox[2].value,CountBox[3].value,t,result,subtot,ResultBox[chosenTab].teltot);  
  }
  
function checkWeekComplete() {
  complete = true;
  for (var i=0; i<7; i++) {
    if (!parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+DagBtn[i].dag+"']")) {
      complete = false;
      break;
      }
    }
  if (complete) {
    WeekBtn.style.visibility = 'inherit';
    stepDotStep = 3;
    stepIt();    
    }
  else WeekBtn.style.visibility = 'hidden';
  }
  
function getWeek() {
  CountBox[1].value = 0;
  CountBox[2].value = 0;
  CountBox[3].value = 0;
  
  ResultBox[0].innerText = '0';
  ResultBox[1].innerText = '0';
  ResultBox[2].innerText = '0';
  ResultBox[3].innerText = '0';
  ResultBox[4].innerText = '0';
  
  for (var i=0; i<7; i++) {
    if (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+DagBox[i].parentElement.dag+"']")) {
      DagBox[i].innerText = parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+DagBox[i].parentElement.dag+"']").getAttribute("totaal");
      DagBox[i].className = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+DagBox[i].parentElement.dag+"']").getAttribute("result")=='g')?'dagBoxGreen':'dagBoxRed';
      }
    else {
      DagBox[i].innerText = '0';
      DagBox[i].className = 'dagBoxNeutral';
      }
    }
  VoorbeeldButtons('hide');

  WeekArea.style.visibility = 'hidden';
  WeekResultImg.src = "images/weekresult_oranje.bmp";
  weekResult = false;   

  checkWeekComplete();
  }

function getDag() {
  if (!parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']")) { // week?
    newWeek = parent.xmlUserData.createElement("week");
    newWeek.setAttribute("num",weekNum);
    parent.userRoot.selectSingleNode("data").appendChild(newWeek);
    }
  if (!parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']")) { // dag?
    newDag = parent.xmlUserData.createElement("dag");
    newDag.setAttribute("naam",chosenDag);
    newDag.setAttribute("totaal","0");
    newDag.setAttribute("result","");
    newDag.setAttribute("gewicht",gewicht);
    parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']").appendChild(newDag);    
    }
    
  CountBox[1].value = 0;
  CountBox[2].value = 0;
  CountBox[3].value = 0;    
  
  ResultBox[0].teltot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '0']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '0']").getAttribute("teltot"):'0';  
  ResultBox[0].subtot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '0']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '0']").getAttribute("subtot"):'0';
  ResultBox[0].innerText = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '0']"))?Math.round(parseFloat(ResultBox[0].subtot)):'0';
  ResultBox[1].teltot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '1']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '1']").getAttribute("teltot"):'0';  
  ResultBox[1].subtot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '1']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '1']").getAttribute("subtot"):'0';
  ResultBox[1].innerText = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '1']"))?Math.round(parseFloat(ResultBox[1].subtot)):'0';
  ResultBox[2].teltot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '2']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '2']").getAttribute("teltot"):'0';  
  ResultBox[2].subtot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '2']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '2']").getAttribute("subtot"):'0';
  ResultBox[2].innerText = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '2']"))?Math.round(parseFloat(ResultBox[2].subtot)):'0';
  ResultBox[3].teltot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '3']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '3']").getAttribute("teltot"):'0';  
  ResultBox[3].subtot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '3']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '3']").getAttribute("subtot"):'0';
  ResultBox[3].innerText = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '3']"))?Math.round(parseFloat(ResultBox[3].subtot)):'0';
  ResultBox[4].teltot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '4']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '4']").getAttribute("teltot"):'0';  
  ResultBox[4].subtot = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '4']"))?parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '4']").getAttribute("subtot"):'0';
  ResultBox[4].innerText = (parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '4']"))?Math.round(parseFloat(ResultBox[4].subtot)):'0';

  parent.xmlUserData.save(parent.userDataFileName);
  }
  
function putResultInDag(r1,r2,r3,t,result,subtot,teltot) {
  if (!parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']")) {
    newAct = parent.xmlUserData.createElement("act");
    newAct.setAttribute("num",chosenTab);
    parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']").appendChild(newAct);
    }
  parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']").setAttribute("r1",r1);
  parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']").setAttribute("r2",r2);
  parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']").setAttribute("r3",r3);
  parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']").setAttribute("subtot",subtot);
  parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']").setAttribute("teltot",teltot);  
  parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']").setAttribute("totaal",t);
  parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']").setAttribute("result",result);
  
  parent.xmlUserData.save(parent.userDataFileName);    
  }
  
function getTab() {
  if (!parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']")) {
    CountBox[1].value = 0;
    CountBox[2].value = 0;
    CountBox[3].value = 0;
    }
  else {
    CountBox[1].value = parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']").getAttribute("r1");
    CountBox[2].value = parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']").getAttribute("r2");
    CountBox[3].value = parent.userRoot.selectSingleNode("data/week[@num = '"+weekNum+"']/dag[@naam = '"+chosenDag+"']/act[@num = '"+chosenTab+"']").getAttribute("r3");
    }
  VoorbeeldButtons('show');
  }
  
function VoorbeeldButtons(t) {
  VoorbeeldBtn[0].style.visibility = (t=='hide')?"hidden":"visible";
  VoorbeeldBtn[1].style.visibility = (t=='hide')?"hidden":"visible";
  VoorbeeldBtn[2].style.visibility = (t=='hide')?"hidden":"visible";
  }
  
function buildWeek(t) {
  WeekArea.style.visibility = 'inherit';
  WeekResultImg.filters.blendTrans.Apply();
  if (t<3) theSrc = "images/weekresult_groen.bmp";
  else if (t>3) theSrc = "images/weekresult_rood.bmp";
  else theSrc = "images/weekresult_oranje.bmp";
  WeekResultImg.src = theSrc;
  WeekResultImg.filters.blendTrans.Play();
  
  WeekTitle.innerText = moduleRoot.selectNodes("//result")[t].selectSingleNode("titel").text;
  
  styleRule = '<?xml version="1.0"?>';
  styleRule += '<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">';
  styleRule += '<xsl:template match="/">';
  styleRule += '<xsl:apply-templates select="//result['+t+']/tekst">';
  styleRule += '<xsl:template>';
  styleRule += '<xsl:copy>';
  styleRule += '<xsl:apply-templates select="@* | * | comment() | pi() | text()"/>';
  styleRule += '</xsl:copy>';
  styleRule += '</xsl:template>';
  styleRule += '</xsl:apply-templates>';
  styleRule += '</xsl:template>';
  styleRule += '</xsl:stylesheet>';    

  style = new ActiveXObject("Microsoft.XMLDOM");
  style.loadXML(styleRule);  
  
  WeekTekst.innerHTML = moduleData.transformNode(style);  
  }

var countTimer;
var counting = false;
var countObj;
  
function RealCount() {
  clearTimeout(countTimer);
  
  theNum = parseInt(countObj.num);
  theFactor = (countObj.factor)?parseInt(countObj.factor):1;
  theValue = parseInt(CountBox[theNum].value);
  if (((countObj.innerText == '-') || (countObj.dirtype == '-')) && ((theValue-theFactor) >= minMax[theNum*2])) {
    theValue -= theFactor;
    }
  else if (((countObj.innerText == '+') || (countObj.dirtype == '+')) && ((theValue-theFactor) <= minMax[(theNum*2)+1])) {
    theValue += theFactor;
    }
  CountBox[theNum].value = theValue;
  CountAction(theNum);
    
  if (counting) countTimer = window.setTimeout('RealCount()',100);
  }