var chosenVraag = -1;
var vraagArray = new Array(-1,-1,-1,-1,-1,-1,-1,-1,-1,-1);
var antwoordArray = new Array('','','','','','','','','','');
var conclusieMode = 0;

var moduleData = new ActiveXObject("Microsoft.XMLDOM");
moduleData.load("data/kennistest.xml");
var moduleRoot = moduleData.documentElement;

function showPage() {
  buildPage();
  parent.goPage = 'kennistest.html';  
  AppScreen.style.visibility = "visible";
  }

function buildPage() {
  styleRule = '<?xml version="1.0"?>';
  styleRule += '<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">';
  styleRule += '<xsl:template match="/">';
  styleRule += '<xsl:apply-templates select="kennistest/text">';
  styleRule += '<xsl:template>';
  styleRule += '<xsl:copy>';
  styleRule += '<xsl:apply-templates select="@* | * | comment() | pi() | text()"/>';
  styleRule += '</xsl:copy>';
  styleRule += '</xsl:template>';
  styleRule += '</xsl:apply-templates>';
  styleRule += '</xsl:template>';
  styleRule += '</xsl:stylesheet>';

  style = new ActiveXObject("Microsoft.XMLDOM");
  style.loadXML(styleRule);
  
  TextArea.innerHTML = moduleData.transformNode(style);
  
  Count = 0;
  Aantal = moduleRoot.selectNodes("vraag").length-1;
  while (Count < 10) {
    theNumber = Math.round(Aantal * Math.random());
    alreadyExists = false;
    for (var i=0; i<Count; i++) {
      if (vraagArray[i] == theNumber) alreadyExists = true;
      }
    if (alreadyExists != true) {
      vraagArray[Count] = theNumber;
      Count ++;
      }
    }

  vraagWriteString = '';
  for (var i=0; i<vraagArray.length; i++) {
    vraagWriteString += '<div id="VraagBtn" num="' + i + '" style="left:'+ (64+(i*50)) +'px">' + (i+1) + '</div>';
    }
  VraagBtnArea.innerHTML = vraagWriteString;  
  }

function doVraag(n) {
  chosenVraag = n;
  TextArea.innerHTML = '<u>Vraag ' + (chosenVraag+1) + ' </u><p>' + moduleRoot.selectNodes("vraag")[(vraagArray[chosenVraag])].selectSingleNode("text").text;
  if (antwoordArray[chosenVraag] == 'g') {
    AntwoordBtn[0].src = 'images/bt_juist_2.bmp';
    AntwoordBtn[1].src = 'images/bt_onjuist_0.bmp';
    }
  else if (antwoordArray[chosenVraag] == 'f') {
    AntwoordBtn[0].src = 'images/bt_juist_0.bmp';
    AntwoordBtn[1].src = 'images/bt_onjuist_2.bmp';
    }
  else {
    AntwoordBtn[0].src = 'images/bt_juist_0.bmp';
    AntwoordBtn[1].src = 'images/bt_onjuist_0.bmp';
    }  
  AntwoordBtn[0].style.visibility = 'inherit';
  AntwoordBtn[1].style.visibility = 'inherit';  
  }

function doAntwoord() {
  styleRule = '<?xml version="1.0"?>';
  styleRule += '<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">';
  styleRule += '<xsl:template match="/">';
  styleRule += '<xsl:apply-templates select="kennistest/vraag['+vraagArray[chosenVraag]+']/layout">';
  styleRule += '<xsl:template>';
  styleRule += '<xsl:copy>';
  styleRule += '<xsl:apply-templates select="@* | * | comment() | pi() | text()"/>';
  styleRule += '</xsl:copy>';
  styleRule += '</xsl:template>';
  styleRule += '</xsl:apply-templates>';
  styleRule += '</xsl:template>';
  styleRule += '</xsl:stylesheet>';    

  style = new ActiveXObject("Microsoft.XMLDOM");
  style.loadXML(styleRule);
  
  FbkArea.innerHTML = '<p>' + ((antwoordArray[chosenVraag] == 'g')?'Goed geantwoord.</p>':'Fout geantwoord.</p>') + moduleData.transformNode(style);  
  FbkArea.style.visibility = 'inherit';
  FbkBtn.style.visibility = 'hidden';
  
  allesKlaar = true;
  for (var i=0; i<antwoordArray.length; i++) {
    if (antwoordArray[i] == '') allesKlaar = false;
    }
    
  if (allesKlaar) {
    FbkBtn.style.visibility = 'inherit';
    conclusieMode = 1;
    }
  }
  
function doConclusie() {
  foutCount = 0;
  for (var i=0; i<antwoordArray.length; i++) {
    if (antwoordArray[i] == 'f') foutCount ++;
    }  
  
  for (var i=0; i<moduleRoot.selectNodes("fbk").length; i++) {
    minCount = parseFloat(moduleRoot.selectNodes("fbk")[i].getAttribute("min"));
    maxCount = parseFloat(moduleRoot.selectNodes("fbk")[i].getAttribute("max"));
    if ((foutCount >= minCount) && (foutCount < maxCount)) {
      FbkArea.innerHTML = moduleRoot.selectNodes("fbk")[i].text;
      }
    }  
  conclusieMode = 2;
  }